; OPT_Res	0	   ; RichMasm thinks this code needs no resources - delete if rsrc.rc is needed
include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc		; useful because of deb 1, "MACRO", eax, ecx, edx
.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
; include \masm32\Gfa2Masm\Cyct_Macros.inc	; [url=\masm32\Gfa2Masm\Cyct_Macros.inc]open[/url]
; ######################################
; you may predefine some paras

ifndef counter_begin
	include \masm32\macros\timers.asm
endif
ifndef cyctCutFast
	cyctCutFast = 15
endif
ifndef cyctShowSlow
	cyctShowSlow = 0
endif
ifndef cyctShowDiff
	cyctShowDiff = 0
endif
ifndef cyctShowSize
	cyctShowSize = 1
endif

cyctSleepMs = 	20
cyctShowSize = 	0
.data?
cyctSize	dd ?
cyctStrLen	dd ?
cyctCounter	dd ?, ?, ?, ?, ?
cyctSortTable	dd 1000 dup(?)	; overwrites next dd
cyctTableMode	SDWORD ?
.const

cyct_begin MACRO cyct_lc, cyct_prio	;; both arguments are optional
LOCAL cyct_prioclass, lbl
  ifdef cyctSleepMs
	invoke Sleep, cyctSleepMs
  endif
  ifnb <cyct_lc>
	cyctSubCt = cyct_lc/1000 				;; 1000 entries in cyctSortTable
  else
	cyctSubCt = LOOP_COUNT/1000
  endif
  if cyctSubCt lt 50
  	cyctSubCt = 50
  	; 25 seems to be the minimum for reasonable timings
  endif
  ifnb <cyct_prio>
	cyct_prioclass equ <cyct_prio> 		;; v v default below
  else
	cyct_prioclass equ HIGH_PRIORITY_CLASS
  endif
  ; int 3
  and cyctCounter, 0								;; clear the counter
  mov cyctSize, offset lbl
  .Repeat
	counter_begin cyctSubCt, cyct_prioclass
lbl:	
	
ENDM
; -------------------------------------------------------------------------	mov eax, len(offset Tst50)	; the code in between the two macros ---------------------
cyct_end MACRO arg
LOCAL tmp$, lbl
lbl:
  counter_end
  	mov edx, cyctCounter
  	mov [cyctSortTable+4*edx], eax
	inc cyctCounter
  .Until edx>=sizeof cyctSortTable/4-1
  sub cyctSize, offset lbl
  neg cyctSize
  tmp$ CATSTR <mov eax, chr$(">, <arg>, <",13,10)>
  ;% echo tmp$
  tmp$
  call cyct_endP	;; calculate and show results
ENDM

.code
cyct_endP proc
  push ebp
  push esi
  push ebx
  push eax
  inc edx
  invoke CombSortA, offset cyctSortTable, edx
  xor ebx, ebx
  ; ifline cyctTableMode!<=0, print chr$(13, 10)
  if cyctShowSlow
	print chr$(10)
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyctSortTable+4*ebx]
		print str$(eax), " "
	  	inc ebx
	.Until ebx>cyctCutFast
	if cyctShowSlow gt 0
		print chr$(13, 10, 10, "...", 13, 10, 10)
		mov ebx, cyctCounter
		sub ebx, cyctShowSlow
		.Repeat
  			print str$(ebx), ":"
			mov eax, [cyctSortTable+4*ebx]
			print str$(eax), " "
  			inc ebx
		.Until ebx>=cyctCounter
	endif
  endif
  pop ebp	; pushed as eax
  if cyctShowDiff
  .if byte ptr [ebp]!="#"
	print chr$(13, 10)
	print ebp
	print chr$(13, 10, "average with cutoff", 9)
  .endif
  endif
  push cyctCutFast
  pop ebx
  mov eax, [cyctSortTable+4*cyctCutFast]		;; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyctSortTable+4*ebx]
	inc ebx
	.Break .if ecx>esi
	add eax, ecx
  .Until ebx>cyctCounter
  sub ebx, cyctCutFast+2
  je @F
  cdq
  div ebx
  @@:
  push eax
  .if cyctTableMode
	; printFix cyctColW, str$(eax)		; the actual cycles
  .else
	print str$(eax)
  .endif
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
			print chr$(32, 9, "cutoff at n=")
			add ebx, cyctCutFast+1
			print str$(ebx), " for ", 62		; >n cycles
			print str$(esi), " cycles"
		.else
  			print chr$(32, 9, "no cutoff")
		.endif
		print chr$(13, 10, "average w/o cutoff ", 9)
	else
		.if cyctTableMode==0
			.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
				add ebx, cyctCutFast+1
				.if ebx<400
					print "*"
				.endif
			.endif
			print chr$(9)
			print ebp
		.endif
	endif
  .endif
  xor eax, eax
  xor ebx, ebx
  mov edx, cyctCounter
  .Repeat
	add eax, [cyctSortTable+4*ebx]
	inc ebx
  .Until ebx>edx
  test eax, eax
  js @F	; something is wrong here
  dec ebx
  je @F	; rare event
  cdq
  div ebx
  @@:
  mov ebx, eax
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		print str$(eax), 13, 10, "difference raw-cutoff:", 9
		sub ebx, [esp]
		print str$(ebx)
	endif
  .endif
  if cyctShowSize
	print "    ", 9, "codesize="
	print str$(cyctSize), " bytes"
  endif
  pop eax
  pop ebx
  pop esi
  pop ebp
  ret
cyct_endP endp
.const

; ######################################

LOOP_COUNT	= 100000

bin2byte_exLib	PROTO: DWORD
ShowCpu	PROTO:DWORD

; ML assembler version 6.15 supports XMM instructions, except the
; instructions MOVSD and CMPSD which are confused with integer string
; instructions with the same names. ([url=http://www.masm32.com/board/index.php?topic=12719.msg98468#msg98468]Greg Lyon[/url])

MOVSD_ MACRO A, B
  DB 0F2H
  MOVUPS A, B
ENDM

CMPSD_ MACRO A, B, C
  DB  0F2H
  CMPPS A, B, C
ENDM

ifndef f2sBuffer
  .data?
  f2sBuffer	dd 20 dup(?)
endif

.code
t0	db "00000000", 0, "11111111111111111111111"
tm	db "01010101", 0, "11111111111111111111111"
t1	db "11111111", 0, "11111111111111111111111"

start:	invoke ShowCpu, 1
	print chr$(13, 10)
;	push offset t1
;	call BinTest
;	print str$(eax)
;	getkey
;	exit
	push offset t0
	call BinValSSE

; TESTS
;	push chr$("00000000y1010=8")
;	call BinValJJvs

	if 0
	push chr$("1100111y1010=7")
	call BinValJJvs

	push chr$("11000111y1010=8")
	call BinValJJvs

	push chr$("110000000001111y1010=15")
	call BinValJJvs

	push chr$("1100000000001111y1010=16")
	call BinValJJvs

	push chr$("11000000000000110011100001111y1010=29")
	call BinValJJvs

	push chr$("11000000000000000110011100001111y1010=32")
	call BinValJJvs

	push chr$("110000000000000000110011100001111y1010=33")
	call BinValJJvs

	Exit
	endif

; ############################# Timings #############################
	REPEAT 3
	cyct_begin
		push offset t0
		call Bin2Dw
		push offset tm
		call Bin2Dw
		push offset t1
		call Bin2Dw
	cyct_end <Bin2Dw       (drizz+JJ, variable size)>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call bin2byte_min_386
		push offset tm
		call bin2byte_min_386
		push offset t1
		call bin2byte_min_386
	cyct_end <bin2byte_min_386 (fixed size)>
	print offset f2sBuffer


;	cyct_begin
;		push offset t0
;		call BinValSSE_bt
;		push offset tm
;		call BinValSSE_bt
;		push offset t1
;		call BinValSSE_bt
;	cyct_end <BinValSSE_bt (JJ, variable size)>
;	print offset f2sBuffer

;	cyct_begin
;		push offset t0
;		call BinVal0
;		push offset tm
;		call BinVal0
;		push offset t1
;		call BinVal0
;	cyct_end <BinVal0 (JJ, fixed size)>
;	print offset f2sBuffer

	cyct_begin
		push offset t0
		call BinValJJvs
		push offset tm
		call BinValJJvs
		push offset t1
		call BinValJJvs
	cyct_end <BinValJJvs   (SSE2, variable size)>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call BinValJJ
		push offset tm
		call BinValJJ
		push offset t1
		call BinValJJ
	cyct_end <BinValJJ     (SSE2, 8 bits)>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call BinValJL
		push offset tm
		call BinValJL
		push offset t1
		call BinValJL
	cyct_end <BinValJL     (SSE2)>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call BinValLingo
		push offset tm
		call BinValLingo
		push offset t1
		call BinValLingo
	cyct_end <BinValLingo  (SSE2)>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call simd_bin2byteLingo
		push offset tm
		call simd_bin2byteLingo
		push offset t1
		call simd_bin2byteLingo
	cyct_end <simd_bin2byteLingo>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call bin2byte_min0_SSE
		push offset tm
		call bin2byte_min0_SSE
		push offset t1
		call bin2byte_min0_SSE
	cyct_end <bin2byte_min0_SSE>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call bin2byte_min_SSE2
		push offset tm
		call bin2byte_min_SSE2
		push offset t1
		call bin2byte_min_SSE2
	cyct_end <bin2byte_min_SSE2>
	print offset f2sBuffer

	cyct_begin
		push offset t0
		call bin2byte_exLib
		push offset tm
		call bin2byte_exLib
		push offset t1
		call bin2byte_exLib
	cyct_end <bin2byte_exLib>
	print offset f2sBuffer, 13, 10

	ENDM

; Tests for correctness (only one algo at a time, sorry, e.g. simd_bin2byte, bin2byte_exLib, BinValSSE, BinVal3, BinValSSE_bt)
bvVarSize = 0	; variable size algo test?

if bvVarSize eq 0
  Algo equ simd_bin2byteLingo
else
  Algo equ BinValJJ
endif

if bvVarSize
	bvVarTest equ <, over 8 bits: -1, 1431655765>
else
	bvVarTest equ <>
endif

  tmp$ CATSTR <print chr$("Testing >, Algo, < (2 lines must match):", 13, 10, "0, 3, 12, 48, 192, 255>, bvVarTest, <", 13, 10)>
  tmp$
	; push chr$("01111101010101010101010101000001y")
	push chr$("00000000y")
	; push chr$("11110000y")
	call Algo
	print str$(eax), ", "

	push chr$("00000011y")
	call Algo
	print str$(eax), ", "

	push chr$("00001100y")
	call Algo
	print str$(eax), ", "

	push chr$("00110000y")
	call Algo
	print str$(eax), ", "

	push chr$("11000000y")
	call Algo
	print str$(eax), ", "

	push chr$("11111111y")
	call Algo
	print str$(eax)
	if bvVarSize
	  print ", over 8 bits: "

	  push chr$("11111111111111111111111111111111y")
	  call Algo
	  print str$(eax), ", "

	  push chr$("01010101010101010101010101010101y")
	  .data
	  v1	dd 01010101010101010101010101010101y
	  .code
	  call Algo
	  push eax

	  print str$(eax), 13, 10
	  pop eax
	  if 0
	  .if eax!=1431655765
		print "Last item different: Apparently, the algo does not recognize formats different", 13, 10,\
		"from '10101010', i.e. it needs fixed 8 chars or 8 chars plus zero delimiter"
	  .endif
	  endif
	endif
	print chr$(13, 10, 10, "Code sizes:", 13, 10)
	mov eax, Bin2Dw_END
	sub eax, Bin2Dw
	print str$(eax), " bytes Bin2Dw (drizz+JJ)", 13, 10

	mov eax, bin2byte_min_386_END
	sub eax, bin2byte_min_386
	print str$(eax), " bytes ..mineiro 386 (fixed size)", 13, 10

;	mov eax, BinValSSE_bt_END
;	sub eax, BinValSSE_bt
;	print str$(eax), " bytes BinValSSE_bt (JJ)", 13, 10

;	mov eax, BinValSSE_END
;	sub eax, BinValSSE
;	print str$(eax), " bytes BinValSSE", 13, 10

	mov eax, BinValJJvs_END
	sub eax, BinValJJvs
	print str$(eax), " bytes BinValJJvs", 13, 10

	mov eax, BinValJJ_END
	sub eax, BinValJJ
	print str$(eax), " bytes BinValJJ", 13, 10

	mov eax, BinValJL_END
	sub eax, offset bvMask	; BinValJL
	print str$(eax), " bytes BinValJL", 13, 10

	mov eax, BinValLingo_END
	sub eax, offset mask1		; not BinValLingo, because mask1 is initialised data
	print str$(eax), " bytes BinValLingo (Lingo)", 13, 10

	if 0
	mov eax, BinVal1_END
	sub eax, BinVal1
	print str$(eax), " bytes BinVal1 (JJ)", 13, 10
	endif

;	mov eax, BinVal2_END
;	sub eax, BinVal2
;	print str$(eax), " bytes BinVal2 (JJ)", 13, 10

;	mov eax, BinVal3_END
;	sub eax, BinVal3
;	print str$(eax), " bytes BinVal3", 13, 10

;	mov eax, simd_bin2byte_END
;	sub eax, simd_bin2byte
;	print str$(eax), " bytes simd_bin2byte (qWord)", 13, 10

	mov eax, simd_bin2byteLingo_END
	sub eax, simd_bin2byteLingo
	print str$(eax), " bytes simd_bin2byteLingo", 13, 10

;	mov eax, BinToDw_END
;	sub eax, BinToDw
;	print str$(eax), " bytes BinToDw", 13, 10

;	mov eax, b2dw1_END
;	sub eax, b2dw1
;	print str$(eax), " bytes b2dw1", 13, 10

	mov eax, bin2byte_min0_SSE_END
	sub eax, bin2byte_min0_SSE
	print str$(eax), " bytes .._min0_SSE (mineiro)", 13, 10

	mov eax, bin2byte_exLib_END
	sub eax, bin2byte_exLib
	print str$(eax), " bytes bin2byte_ex (Masm32 library)", 13, 10

	inkey chr$(9, 9, 9, 9, 9, 9, " - hit any key -")
	exit

; ################### Algos ############################

align 16	; [url=http://www.masm32.com/board/index.php?topic=12719.msg98094#msg98094]qWord[/url]
simd_bin2byte proc 	; psz:DWORD
	mov eax, [esp+4]
	; MOVSD_ xmm0, QWORD ptr [eax]	; mlv615 and JWasm complain: Tmp_File.asm(304) : Error A2084: Invalid operand size for instruction
	movlps xmm0, QWORD ptr [eax]	; workaround; OPT_Assembler JWasm
	pxor xmm1, xmm1
	psllq xmm0, 7
	punpcklbw xmm0, xmm1
	pshuflw xmm0, xmm0, 00011011y
	pshufhw xmm0, xmm0, 00011011y
	packuswb xmm0, xmm0
	pshufd xmm0, xmm0, 011100001y
	pmovmskb eax, xmm0
	movzx eax, al
	ret 4
simd_bin2byte endp
simd_bin2byte_END:

align 16
simd_bin2byteB proc 	; psz:DWORD
	pop ecx
	pop eax
	; MOVSD_ xmm0, QWORD ptr [eax]	; mlv615 and JWasm complain: Tmp_File.asm(304) : Error A2084: Invalid operand size for instruction
	movlps xmm0, QWORD ptr [eax]	; workaround
	pxor xmm1, xmm1
	psllq xmm0, 7
	punpcklbw xmm0, xmm1
	pshuflw xmm0, xmm0, 00011011y
	pshufhw xmm0, xmm0, 00011011y
	packuswb xmm0, xmm0
	pshufd xmm0, xmm0, 011100001y
	pmovmskb eax, xmm0
	movzx eax, al
	jmp ecx
simd_bin2byteB endp
simd_bin2byteB_END:

align 16	; based on [url=http://www.masm32.com/board/index.php?topic=12719.msg98094#msg98094]qWord[/url], "improved" by [url=http://www.masm32.com/board/index.php?topic=12719.msg98492#msg98492]Lingo[/url], then made operational by jj2007
simd_bin2byteLingo proc 	; psz:DWORD
	pop ecx												
	cmp byte ptr bvjTable1[4], 0				
	pop edx		
	movlps xmm0,	qword ptr [edx]
	je bvjCreate1									
bvjChk1:
	UseXmm7 = 1		; jj proposes 0
	if UseXmm7
		pcmpeqb xmm0, xmm7			; Lingo is confident that nobody else will use xmm7
	else
		pcmpeqb xmm0, bvjMask1	; equally fast, and 3 bytes shorter
	endif
	pmovmskb eax, xmm0
	mov al,	[bvjTable1+eax]
	jmp ecx												
.data?
align 16
bvjMask1	dd	4 dup(?)
bvjTable1	db	256 dup(?)
.code
bvjCreate1:
	push		edi
	push		esi
	push		edx
	push		ecx
	mov		edi, offset bvjMask1
	mov		eax, "1111"
	stosd
	stosd
	stosd
	stosd
	xor	ecx, ecx
	if UseXmm7
		movups xmm7, oword ptr [bvjMask1]	; JJ: get 16 chars (OK)
;		 movlps xmm7, qword ptr [bvjMask1]	; Lingo: get 8 chars (fails)
	endif
bvjLoop1:
	m2m esi, 8			; set inner counter
	mov edx, ecx		; the source word
@@:
	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1				; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the byte in bvjTable
	inc cl		; ecx lobyte, eq for 256
	jne bvjLoop1
	pop ecx
	pop edx
	pop esi
	pop edi
	jmp bvjChk1	; done, start using the table
simd_bin2byteLingo endp
simd_bin2byteLingo_END:

align 16
BinVal0 proc 	; lpSrc			; 54 bytes; 8 bits fixed length
	pop ecx			; ret address
	pop edx			; pointer to src$
	mov eax, "1111"		; bits set
	movd xmm2, eax
	pshufd xmm2, xmm2, 0	; "1" propagated to xmm2
	mov eax, [edx]
	bswap eax
	movd xmm0, eax
	mov eax, [edx+4]
	bswap eax
	movd xmm1, eax
	punpckldq xmm1, xmm0	; interleave low dwords
	pcmpeqb xmm1, xmm2	; compare packed bytes to "1"
	pmovmskb eax, xmm1	; set byte mask 0 in edx
	; movzx eax, al		; no longer needed
	jmp ecx
BinVal0 endp
BinVal0_END:

align 16
BinValJJ proc 	; lpSrc				; 71 bytes including the mask; 8 bits fixed length
	cmp dword ptr bvjTable[4], 0		; table already created?
	je bvjCreate
bvjChk:	pop ecx				; ret address
	pop edx				; pointer to src$
	movlps xmm0, qword ptr [edx]		; get 8 chars
	pcmpeqb xmm0, oword ptr [bvjMask]	; compare packed bytes to "1" (oword = xmmword)
	pmovmskb edx, xmm0		; set byte mask 0 in edx
	if 0	; 1 byte shorter but slower on P4
		mov al, [bvjTable+edx]		; pick retval from table
	else
		movzx eax, byte ptr [bvjTable+edx]	; pick retval from table
	endif
	jmp ecx
.data?
  align 16
  bvjMask	dd 4 dup(?)	; 1111111111111111
  bvjTable	db 256 dup(?)
.code
bvjCreate:	pushad		; this part runs exactly once
	mov edi, offset bvjMask
	mov eax, "1111"
	m2m ecx, 4
	rep stosd		; ecx zero on exit
bvjLoop:	m2m esi, 8	; set inner counter
	mov edx, ecx	; the source word
@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the byte in bvjTable
	inc cl		; ecx lobyte, eq for ecx=256
	jne bvjLoop
	popad
	jmp bvjChk	; done, start using the table
BinValJJ endp
BinValJJ_END:

align 16
BinValP4 proc 	; lpSrc				; 76 bytes including the mask; 8 bits fixed length
	cmp byte ptr bvjTable4[4], 0		; table already created?
	; je bvjCreate
	jne bvjChk
bvjCreate:	pushad		; this part runs exactly once
	mov edi, offset bvjMask4
	mov eax, "1111"
	m2m ecx, 4
	rep stosd		; ecx zero on exit
bvjLoop:	m2m esi, 8	; set inner counter
	mov edx, ecx	; the source word
@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the byte in bvjTable
	inc cl		; ecx lobyte, eq for ecx=256
	jne bvjLoop
	popad
	; jmp bvjChk	; done, start using the table
bvjChk:	pop ecx				; ret address
	pop edx				; pointer to src$
	movlps xmm0, qword ptr [edx]		; get 8 chars
	pcmpeqb xmm0, oword ptr [bvjMask4]	; compare packed bytes to "1" (oword = xmmword)
	pmovmskb edx, xmm0		; set byte mask 0 in edx
	if 0	; 1 byte shorter but slower on P4
		mov al, [bvjTable4+edx]		; pick retval from table
	else
		movzx eax, byte ptr [bvjTable4+edx]	; pick retval from table
	endif
	jmp ecx
.data?
  align 16
  bvjMask4	dd 4 dup(?)	; 1111111111111111
  bvjTable4	db 256 dup(?)
.code
BinValP4 endp
BinValP4_END:

align 16
BinValJJvs proc 	; lpSrc				; 76 bytes including the mask; 8 bits fixed length
	cmp byte ptr bvjTablevs[4], 0		; table already created?
	je bvjCreate
bvjChk:	pop ecx				; ret address
	pop edx				; pointer to src$
	push edi
	push ecx
	mov edi, edx
	push esi
	push edi
	xor esi, esi
@@:	movdqu xmm0, oword ptr [edi]		; movups and movlps/hps 35 cycles slower on P4
	; lddqu xmm0, oword ptr [edi]		; movups and movlps/hps 35 cycles slower on P4
	movdqa xmm1, xmm0
	pcmpeqb xmm0, oword ptr [bvjMaskvs]	; compare packed bytes to "1" (oword = xmmword)
	pmovmskb eax, xmm0		; set byte mask 1 in eax
	movzx ecx, ah
	movzx edx, byte ptr bvjTablevs[ecx]	; get inversed byte from table
	movzx ecx, al
	mov dh, bvjTablevs[ecx]
	add esi, edx
	pcmpeqb xmm1, oword ptr [bvjMaskvs+16]	; compare packed bytes to "0" (oword = xmmword)
	pmovmskb edx, xmm1		; set byte mask 0 in edx
	or edx, eax
	not edx
	bsf ecx, edx		; ecx = # bits used, ok
	sub ecx, 16
	neg ecx
	jne @F
	cmp edi, [esp]		; pointer already used?
	jne @F
	add edi, 16		; shift pointer up
	shl esi, 16
	jmp @B

@@:	shr esi, cl
	mov eax, esi
	pop edi
	pop esi
	pop ecx
	pop edi
	jmp ecx
.data?
align 16
bvjMaskvs	dd 8 dup(?)
bvjTablevs	db 256 dup(?)
.code
bvjCreate:	push edi
	push esi
	mov edi, offset bvjMaskvs
	mov eax, "1111"
	stosd
	stosd
	stosd
	stosd
	mov eax, "0000"
	stosd
	stosd
	stosd
	stosd
	xor ecx, ecx
bvjLoop:	m2m esi, 8	; set inner counter
	mov edx, ecx	; the source word
@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the byte in bvjTablevs
	inc cl		; ecx lobyte, eq for 256
	jne bvjLoop
	pop esi
	pop edi
	jmp bvjChk	; done, start using the table
BinValJJvs endp
BinValJJvs_END:

align 16	; absolutely needed, otherwise pcmpeqb chokes
bvMask dd "1111", "1111"
BinValJL proc 	; lpSrc			; 45 bytes including the mask; 8 bits fixed length
	pop ecx			; ret address
	pop edx			; pointer to src$
	mov eax, [edx]		; get 4 chars
	bswap eax
	movd xmm0, eax
	mov eax, [edx+4]		; get 4 more
	bswap eax
	movd xmm1, eax
	punpckldq xmm1, xmm0	; interleave low dwords
	; compare packed bytes to "1"
	pcmpeqb xmm1, oword ptr [bvMask]	; oword aka xmmword
	pmovmskb eax, xmm1	; set byte mask 0 in edx
	jmp ecx
BinValJL endp
BinValJL_END:

align 16
; mask1 dq 0Fh,0	; Lingo's version
mask1 dd "1111", "1111"

BinValLingo proc 	; lpSrc
	pop	ecx		
	pop	eax		
	mov	edx, [eax]
	mov	eax, [eax+4]
	bswap	edx
	bswap eax
	movd	xmm0, edx
	movd	xmm1, eax
	punpckldq	xmm1, xmm0
	pcmpeqb		xmm1, oword ptr [mask1]	; oword aka xmmword
	pmovmskb	eax, xmm1	
	; and eax, 0FFh						; no longer necessary (and, by the way, NOT faster than movzx eax, al ;-)
	jmp ecx
BinValLingo endp
BinValLingo_END:

align 16
BinToDw proc 	; pszbinstr:DWORD
	mov edx, [esp+1*4]
	xor eax, eax
	jmp @F
	.Repeat
		and ecx, 1
		lea eax, [eax*2+ecx]
	@@:	movzx ecx, byte ptr [edx]
		inc edx
		test ecx, ecx
	.Until Zero?
	ret 1*4
BinToDw endp
BinToDw_END:

align 16
Bin2Dw proc 	; pszbinstr:DWORD		; this one stops when char is not "1" or "0"
	mov edx, [esp+4]		; credits [url=http://www.masm32.com/board/index.php?topic=4709.msg35458#msg35458]drizz[/url] with mods by jj2007
	xor eax, eax
	push ecx			; MasmBasic preserves ecx ;-)
	jmp byte1

@@:	and ecx, 1
	lea eax, [eax*2+ecx]	; multiply eax by 2, add one if the char was "1"
byte1:	mov cl, [edx]		; get next char
	inc edx
	cmp cl, "1"
	ja @F
	cmp cl, "0"
	jae @B

@@:	pop ecx
	ret 4
Bin2Dw endp
Bin2Dw_END:	; exactly 32 bytes long

       align	16
       db	90h
       
b2dw1 proc	; lpszbinstr:dword
	mov edx, [esp+4]
	mov ecx, 30h
	xor eax,eax
	cmp cl, [edx]
	ja @j
	@@:
	adc eax, eax
	cmp cl, [edx+1]
	@j:
	ja @f
	adc eax, eax
	cmp cl, [edx+2]
	ja @f
	adc eax, eax
	cmp cl, [edx+3]
	ja @f
	adc eax, eax
	cmp cl, [edx+4]
	ja @f
	adc eax, eax
	cmp cl, [edx+5]
	ja @f
	adc eax, eax
	cmp cl, [edx+6]
	ja @f
	adc eax, eax
	cmp cl, [edx+7]
	ja @f
	adc eax, eax
	cmp cl, [edx+8]
	ja @f
	adc eax, eax
	cmp cl, [edx+9]
	ja @f
	adc eax, eax
	cmp cl, [edx+10]
	ja @f
	adc eax, eax
	cmp cl, [edx+11]
	ja @f
	adc eax, eax
	cmp cl, [edx+12]
	ja @f
	adc eax, eax
	cmp cl, [edx+13]
	ja @f
	adc eax, eax
	cmp cl, [edx+14]
	ja @f
	adc eax, eax
	cmp cl, [edx+15]
	ja @f
	adc eax, eax
	cmp cl, [edx+16]
	lea edx, [edx+16]
	jna @b
	@@:
	ret 4
b2dw1 endp
b2dw1_END:

align 16
BinValSSE_bt proc 	; lpSrc		; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, offset btTable
	mov ebx, [edi+4]		; test if table was already created (clears also outer counter)
	test ebx, ebx
	je btCreate

btChk:	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	xor ebx, ebx
	movzx ecx, ah
	mov bl, btTable[ecx]
	movzx ecx, al
	mov bh, btTable[ecx]
	shl ebx, 16		; move to hiword
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  movzx ecx, ah
	  add bl, btTable[ecx]
	  movzx ecx, al
	  add bh, btTable[ecx]
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shr ebx, cl		; shift by # of bits
	mov eax, ebx		; retval
	pop ebx
	pop edi
	ret 4

.data?
btTable	db 256 dup(?)

.code
btCreate:	m2m esi, 8	; set inner counter
	mov edx, ebx	; the source word

@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the word in btTable
	inc bl
	jne btCreate
;	mov edi, offset btTable
;	int 3
;	mov ebx, ebx
	jmp btChk		; done, start using the table
BinValSSE_bt endp
BinValSSE_bt_END:

align 16
BinValSSE_wt proc 	; lpSrc			; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, offset wdTable
	mov ebx, [edi+4]		; test if table was already created (clears also outer counter)
	test ebx, ebx
	je wtCreate

wtChk:	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	movzx ebx, wdTable[2*eax]
	shl ebx, 16		; move to hiword
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  movzx ecx, wdTable[2*eax]
	  add ebx, ecx
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shr ebx, cl		; shift by # of bits
	mov eax, ebx		; retval
	pop ebx
	pop edi
	ret 4

.data?
wdTable	dw 65536 dup(?)

.code
wtCreate:	m2m esi, 16	; set inner counter
	mov edx, ebx	; the source word

@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosw		; store the word in wdTable
	inc bx
	jne wtCreate
	jmp wtChk		; done, start using the table
BinValSSE_wt endp
BinValSSE_wt_END:

align 16
BinValSSE proc 	; lpSrc			; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	mov ebx, eax
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  mov ecx, eax
	  shl ecx, 16
	  add ebx, ecx
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shl ebx, cl		; shift by # of bits
	mov edx, ebx

	mov eax, edx
	shr  eax,1
	and  edx,055555555h
	and  eax,055555555h
	lea  eax,[2*edx+eax]
	mov  edx,eax
	shr  eax,2
	and  edx,033333333h
	and  eax,033333333h
	lea  eax,[4*edx+eax]
	mov  edx,eax
	shr  eax,4
	and  edx,0F0F0F0Fh
	and  eax,0F0F0F0Fh
	shl  edx,4
	add  eax,edx
	bswap eax

	pop ebx
	pop edi
	ret 4

BinValSSE endp
BinValSSE_END:

align 16
BinValX proc 	; lpSrc			; 44 bytes; this one stops when char is not 1 or 0
	mov edx, [esp+4]		; slow, but 1...32 bits usable
	or eax, -1
	mov ecx, eax
L1:	inc eax			; eax is zero on loop entry
@@:
	inc ecx
	shl eax, 1
	cmp byte ptr [edx+ecx], "0"
	je @B
	cmp byte ptr [edx+ecx], "1"
	je L1
	cmp ecx, 32	; carry set for 0...31, inverted with cmc
	jb @F
	cmp byte ptr [edx], "1"	; set if "0"
@@:	cmc
	rcr eax, 1
	ret 4
BinValX endp
BinValX_END:

align 16
BinVal1 proc 	; lpSrc:DWORD		; this one stops when char is not 1 or 0
	mov edx, [esp+4]
	or eax, -1
	dec edx
L1:	inc eax
L2:
	inc edx
	shl eax, 1
	cmp byte ptr [edx], "0"
	je L2
	cmp byte ptr [edx], "1"
	je L1
	shr eax, 1
	ret 4
BinVal1 endp
BinVal1_END:


align 16
BinVal2 proc 	; lpSrc
	pop ecx		; ret address
	pop eax		; pointer to src$
	mov edx, [eax]	; first 4 bytes of string
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F		; 2 cycles faster than sbb eax, -1
	inc eax
@@:	shl eax, 4		; shift the nibble up, same as xchg al, ah but faster
	mov edx, [esp-4]	; we have popped the pointer, but it's still hanging around
	mov edx, [edx+4]	; next 4 bytes of string
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	jmp ecx
BinVal2 endp
BinVal2_END:

align 16
BinVal2a proc 	; lpSrc
	push ecx			; not saving ecx is slower
	mov ecx, [esp+8]
	mov edx, [ecx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F		; 2 cycles faster than sbb eax, -1
	inc eax
@@:	shl eax, 4
	mov edx, [ecx+4]
	cmp dl, "1"
	jne @F
	add eax, 8	; inc eax
@@:	cmp dh, "1"
	jne @F
	add eax, 4	; 2
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2	; 8
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	pop ecx
	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal2a endp
BinVal2a_END:

xs = 1
align 16
BinVal3 proc 	; lpSrc
;	int 3
	mov eax, [esp+4]
	mov edx, [eax]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal3 endp
BinVal3_END:

align 16
BinVal4 proc 	; lpSrc
	mov edx, [esp+4]
	mov edx, [edx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
BinVal4 endp
BinVal4_END:

OPTION PROLOGUE : NONE
OPTION EPILOGUE : NONE

align 16
bin2byte_min0_SSE proc lpword:DWORD	; [url=http://www.masm32.com/board/index.php?topic=12719.msg153938#msg153938]mineiro 30.1.2012[/url]
	mov eax,[esp+4]
	movq xmm0,[eax]
	pcmpeqb xmm0,msk
	pmovmskb eax,xmm0
	movzx eax,byte ptr [table+eax]
	ret 4
bin2byte_min0_SSE endp
align 16
table 	db  00h, 80h, 40h,  0C0h, 20h,  0A0h, 60h,  0E0h, 10h, 90h, 50h,  0D0h, 30h,  0B0h, 70h,  0F0h
		db  08h, 88h, 48h,  0C8h, 28h,  0A8h, 68h,  0E8h, 18h, 98h, 58h,  0D8h, 38h,  0B8h, 78h,  0F8h
		db  04h, 84h, 44h,  0C4h, 24h,  0A4h, 64h,  0E4h, 14h, 94h, 54h,  0D4h, 34h,  0B4h, 74h,  0F4h
		db  0Ch, 8Ch, 4Ch,  0CCh, 2Ch,  0ACh, 6Ch,  0ECh, 1Ch, 9Ch, 5Ch,  0DCh, 3Ch,  0BCh, 7Ch,  0FCh
		db  02h, 82h, 42h,  0C2h, 22h,  0A2h, 62h,  0E2h, 12h, 92h, 52h,  0D2h, 32h,  0B2h, 72h,  0F2h
		db  0Ah, 8Ah, 4Ah,  0CAh, 2Ah,  0AAh, 6Ah,  0EAh, 1Ah, 9Ah, 5Ah,  0DAh, 3Ah,  0BAh, 7Ah,  0FAh
		db  06h, 86h, 46h,  0C6h, 26h,  0A6h, 66h,  0E6h, 16h, 96h, 56h,  0D6h, 36h,  0B6h, 76h,  0F6h
		db  0Eh, 8Eh, 4Eh,  0CEh, 2Eh,  0AEh, 6Eh,  0EEh, 1Eh, 9Eh, 5Eh,  0DEh, 3Eh,  0BEh, 7Eh,  0FEh
		db  01h, 81h, 41h,  0C1h, 21h,  0A1h, 61h,  0E1h, 11h, 91h, 51h,  0D1h, 31h,  0B1h, 71h,  0F1h
		db  09h, 89h, 49h,  0C9h, 29h,  0A9h, 69h,  0E9h, 19h, 99h, 59h,  0D9h, 39h,  0B9h, 79h,  0F9h
		db  05h, 85h, 45h,  0C5h, 25h,  0A5h, 65h,  0E5h, 15h, 95h, 55h,  0D5h, 35h,  0B5h, 75h,  0F5h
		db  0Dh, 8Dh, 4Dh,  0CDh, 2Dh,  0ADh, 6Dh,  0EDh, 1Dh, 9Dh, 5Dh,  0DDh, 3Dh,  0BDh, 7Dh,  0FDh
		db  03h, 83h, 43h,  0C3h, 23h,  0A3h, 63h,  0E3h, 13h, 93h, 53h,  0D3h, 33h,  0B3h, 73h,  0F3h
		db  0Bh, 8Bh, 4Bh,  0CBh, 2Bh,  0ABh, 6Bh,  0EBh, 1Bh, 9Bh, 5Bh,  0DBh, 3Bh,  0BBh, 7Bh,  0FBh
		db  07h, 87h, 47h,  0C7h, 27h,  0A7h, 67h,  0E7h, 17h, 97h, 57h,  0D7h, 37h,  0B7h, 77h,  0F7h
		db  0Fh, 8Fh, 4Fh,  0CFh, 2Fh,  0AFh, 6Fh,  0EFh, 1Fh, 9Fh, 5Fh,  0DFh, 3Fh,  0BFh, 7Fh,  0FFh
msk 	dq 3131313131313131h
	dq 3131313131313131h
bin2byte_min0_SSE_END:

align 16
bin2byte_min_SSE2 proc lpword:DWORD
	mov eax,[esp+4]
	movq xmm1,[eax]
	movq xmm0,xmm1
	psrlw xmm1,8
	psllw xmm0,8 
	por xmm0,xmm1
	pshuflw xmm0, xmm0,00011011b
	pcmpeqb xmm0, qword ptr [masker]
	pmovmskb eax,xmm0
	ret 4
bin2byte_min_SSE2 endp
align 16
masker dq 3131313131313131h
dq 3131313131313131h


align 16
bin2byte_exLib proc lpword:DWORD

    mov eax, [esp+4]

    cmp BYTE PTR [eax+0], "0"
    jne pass10
    cmp BYTE PTR [eax+1], "0"
    jne pass11
    cmp BYTE PTR [eax+2], "0"
    jne pass12
    cmp BYTE PTR [eax+3], "0"
    jne pass13
    ; -------------------
    mov eax, 0 ; 0000
    jmp nxt
    ; -------------------
  align 4
  pass13:
    ; -------------------
    mov eax, 16 ; 0001
    jmp nxt
    ; -------------------
  align 4
  pass12:
    cmp BYTE PTR [eax+3], "0"
    jne pass14
    ; -------------------
    mov eax, 32 ; 0010
    jmp nxt
    ; -------------------
  align 4
  pass14:
    ; -------------------
    mov eax, 48 ; 0011
    jmp nxt
    ; -------------------
  align 4
  pass11:
    cmp BYTE PTR [eax+2], "0"
    jne pass15
    cmp BYTE PTR [eax+3], "0"
    jne pass16
    ; -------------------
    mov eax, 64 ; 0100
    jmp nxt
    ; -------------------
  align 4
  pass16:
    ; -------------------
    mov eax, 80 ; 0101
    jmp nxt
    ; -------------------
  align 4
  pass15:
    cmp BYTE PTR [eax+3], "0"
    jne pass17
    ; -------------------
    mov eax, 96 ; 0110
    jmp nxt
    ; -------------------
  align 4
  pass17:
    ; -------------------
    mov eax, 112 ; 0111
    jmp nxt
    ; -------------------
  align 4
  pass10:
    cmp BYTE PTR [eax+1], "0"
    jne pass18
    cmp BYTE PTR [eax+2], "0"
    jne pass19
    cmp BYTE PTR [eax+3], "0"
    jne pass110
    ; -------------------
    mov eax, 128 ; 1000
    jmp nxt
    ; -------------------
  align 4
  pass110:
    ; -------------------
    mov eax, 144 ; 1001
    jmp nxt
    ; -------------------
  align 4
  pass19:
    cmp BYTE PTR [eax+3], "0"
    jne pass111
    ; -------------------
    mov eax, 160 ; 1010
    jmp nxt
    ; -------------------
  align 4
  pass111:
    ; -------------------
    mov eax, 176 ; 1011
    jmp nxt
    ; -------------------
  align 4
  pass18:
    cmp BYTE PTR [eax+2], "0"
    jne pass112
    cmp BYTE PTR [eax+3], "0"
    jne pass113
    ; -------------------
    mov eax, 192 ; 1100
    jmp nxt
    ; -------------------
  align 4
  pass113:
    ; -------------------
    mov eax, 208 ; 1101
    jmp nxt
    ; -------------------
  align 4
  pass112:
    cmp BYTE PTR [eax+3], "0"
    jne pass114
    ; -------------------
    mov eax, 224 ; 1110
    jmp nxt
    ; -------------------
  align 4
  pass114:
    ; -------------------
    mov eax, 240 ; 1111
    jmp nxt
    ; -------------------

; ******************************************
; ******************************************
; ******************************************

  align 4
  nxt:

    mov ecx, [esp+4]
    add ecx, 4

    cmp BYTE PTR [ecx+0], "0"
    jne lbl0
    cmp BYTE PTR [ecx+1], "0"
    jne lbl1
    cmp BYTE PTR [ecx+2], "0"
    jne lbl2
    cmp BYTE PTR [ecx+3], "0"
    jne lbl3
    ; -------------------
    ;;; add eax, 0
    ret 4
    ; -------------------
  align 4
  lbl3:
    ; -------------------
    add eax, 1
    ret 4
    ; -------------------
  align 4
  lbl2:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl4
    ; -------------------
    add eax, 2
    ret 4
    ; -------------------
  align 4
  lbl4:
    ; -------------------
    add eax, 3
    ret 4
    ; -------------------
  align 4
  lbl1:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl5
    cmp BYTE PTR [ecx+3], "0"
    jne lbl6
    ; -------------------
    add eax, 4
    ret 4
    ; -------------------
  align 4
  lbl6:
    ; -------------------
    add eax, 5
    ret 4
    ; -------------------
  align 4
  lbl5:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl7
    ; -------------------
    add eax, 6
    ret 4
    ; -------------------
  align 4
  lbl7:
    ; -------------------
    add eax, 7
    ret 4
    ; -------------------
  align 4
  lbl0:
    cmp BYTE PTR [ecx+1], "0"
    jne lbl8
    cmp BYTE PTR [ecx+2], "0"
    jne lbl9
    cmp BYTE PTR [ecx+3], "0"
    jne lbl10
    ; -------------------
    add eax, 8
    ret 4
    ; -------------------
  align 4
  lbl10:
    ; -------------------
    add eax, 9
    ret 4
    ; -------------------
  align 4
  lbl9:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl11
    ; -------------------
    add eax, 10
    ret 4
    ; -------------------
  align 4
  lbl11:
    ; -------------------
    add eax, 11
    ret 4
    ; -------------------
  align 4
  lbl8:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl12
    cmp BYTE PTR [ecx+3], "0"
    jne lbl13
    ; -------------------
    add eax, 12
    ret 4
    ; -------------------
  align 4
  lbl13:
    ; -------------------
    add eax, 13
    ret 4
    ; -------------------
  align 4
  lbl12:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl14
    ; -------------------
    add eax, 14
    ret 4
    ; -------------------
  align 4
  lbl14:
    ; -------------------
    add eax, 15
    ret 4
    ; -------------------

  notfound:
    or eax, -1
    ret 4

bin2byte_exLib endp
bin2byte_exLib_END:




OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
bin2byte_min_386 proc lpword:DWORD
	mov eax,[esp+4]
	mov edx,[eax+4]
	mov ecx,[eax]
	xor eax,eax
and ecx,01010101h
and edx,01010101h
	SHL ECX,7
	SHL EDX,3
	or ecx,edx
	REPT 3
	OR AL,CL
	SHR ECX,9
	endm
	OR AL,CL
	ret 4
bin2byte_min_386 endp
bin2byte_min_386_END:

ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start
OPT_Assembler	mlv615
OPT_WAIT	0
OPT_Tmp2Asm	1
OPT_DelTmp	0

Timings
Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)

160     cycles for Bin2Dw       (drizz+JJ, variable size)
76      cycles for BinValSSE_bt (JJ, variable size)
29      cycles for BinVal0 (SSE2)
23      cycles for BinValJL (SSE2)
25      cycles for BinValLingo (SSE2)
39      cycles for simd_bin2byte
31      cycles for simd_bin2byteB
62      cycles for bin2byte_exLib

P4
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)

177     Bin2Dw       (drizz+JJ, variable size)
176     BinValJJvs   (SSE2, variable size)
41      BinValJJ     (SSE2, 8 bits)
135     BinValJL     (SSE2)
137     BinValLingo  (SSE2)
40      simd_bin2byteLingo
33      bin2byte_min0_SSE
40      bin2byte_min_SSE2
72      bin2byte_exLib

171     Bin2Dw       (drizz+JJ, variable size)
175     BinValJJvs   (SSE2, variable size)
40      BinValJJ     (SSE2, 8 bits)
139     BinValJL     (SSE2)
136     BinValLingo  (SSE2)
36      simd_bin2byteLingo
35      bin2byte_min0_SSE
37      bin2byte_min_SSE2
70      bin2byte_exLib

176     Bin2Dw       (drizz+JJ, variable size)
175     BinValJJvs   (SSE2, variable size)
39      BinValJJ     (SSE2, 8 bits)
139     BinValJL     (SSE2)
139     BinValLingo  (SSE2)
35      simd_bin2byteLingo
32      bin2byte_min0_SSE
36      bin2byte_min_SSE2
69      bin2byte_exLib

Testing simd_bin2byteLingo (2 lines must match):
0, 3, 12, 48, 192, 255
0, 3, 12, 48, 192, 255

Code sizes:
32 bytes Bin2Dw (drizz+JJ)
160 bytes BinValJJvs
71 bytes BinValJJ
45 bytes BinValJL
45 bytes BinValLingo (Lingo)
80 bytes simd_bin2byteLingo
304 bytes .._min0_SSE (mineiro)
472 bytes bin2byte_ex (Masm32 library)
